#include "motor.h"




  uint8_t Motor::pinPwm;



void Motor::setMotorPins(uint8_t pinA , uint8_t pinB){
  this->pinA = pinA;
  this->pinB = pinB;
}

void Motor::setMotorPwmPin(uint8_t pinPwm){
  Motor::pinPwm = pinPwm;
}



void Motor::setup(){
  ArduinoAnpassung::setup();
  Timer1.initialize(100);     //10kHz
  Timer1.pwm(pinPwm , 0);
  Timer1.attachInterrupt(Motor::interruptEinsprung);
}

void Motor::interruptEinsprung(){
  MyList *zeiger;
  zeiger =  ArduinoAnpassung::getErstesElement();
  while(zeiger){
    ((Motor*)zeiger)->memberInterruptEinsprung();
    zeiger = zeiger->getNachfolgerElement();
  }
}

  void Motor::memberInterruptEinsprung(){
  interruptBerechnungen();
}

void Motor::interruptBerechnungen(){
  /*if(sollSpeed > istSpeed){
    istSpeed++;
    setIstSpeed(istSpeed);
  }
  if(sollSpeed < istSpeed){
    istSpeed --;
    setIstSpeed(istSpeed);
  }*/
  
    setIstSpeed(sollSpeed);
  

}




void Motor::setSollSpeed(int16_t speed){
  

 /* if(speed >1023)
    speed = 1023;
  if(speed < -1023)
    speed = -1023; */

  sollSpeed = speed;

}
void Motor::setIstSpeed(int16_t speed){
  uint16_t pwm;

  if(speed > 0)
   { 
    pwm = speed ;
    digitalWrite(pinA , 1);
    digitalWrite(pinB , 0);

  }else if (speed < 0){
    pwm =  -speed ;
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 1);

  }else{
    pwm = 1023;
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 0);

  }
  Timer1.pwm(Motor::pinPwm, pwm);
 

}






void Motor::memberSetup(){
  pinMode(pinA , OUTPUT);
  digitalWrite( pinA , 0);

  pinMode(pinB , OUTPUT);
  digitalWrite(pinB , 0);
}






